Index: XIOS/dev/branch_openmp/src/node/grid.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/grid.cpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/grid.cpp	(revision 1642)
@@ -2447,4 +2581,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2453,4 +2588,5 @@
   */
   void CGrid::setScalarList(const std::vector<CScalar*> scalars)
+  TRY
   {
     if (isScalarListSet) return;
@@ -2474,4 +2610,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2480,8 +2617,10 @@
   */
   std::vector<StdString> CGrid::getDomainList()
+  TRY
   {
     setDomainList();
     return domList_;
   }
+  CATCH
 
   /*!
@@ -2490,8 +2629,10 @@
   */
   std::vector<StdString> CGrid::getAxisList()
+  TRY
   {
     setAxisList();
     return axisList_;
   }
+  CATCH
 
   /*!
@@ -2500,8 +2641,10 @@
   */
   std::vector<StdString> CGrid::getScalarList()
+  TRY
   {
     setScalarList();
     return scalarList_;
   }
+  CATCH
 
   /*!
@@ -2509,4 +2652,5 @@
   */
   void CGrid::sendAllDomains()
+  TRY
   {
     std::vector<CDomain*> domList = this->getVirtualDomainGroup()->getAllChildren();
@@ -2518,4 +2662,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2523,4 +2668,5 @@
   */
   void CGrid::sendAllAxis()
+  TRY
   {
     std::vector<CAxis*> aList = this->getVirtualAxisGroup()->getAllChildren();
@@ -2533,4 +2679,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2538,4 +2685,5 @@
   */
   void CGrid::sendAllScalars()
+  TRY
   {
     std::vector<CScalar*> sList = this->getVirtualScalarGroup()->getAllChildren();
@@ -2548,6 +2696,8 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   void CGrid::setContextClient(CContextClient* contextClient)
+  TRY
   {
     if (clientsSet.find(contextClient)==clientsSet.end())
@@ -2561,4 +2711,5 @@
     	this->getAxis()[i]->setContextClient(contextClient);
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2566,4 +2717,5 @@
   */
   void CGrid::parse(xml::CXMLNode& node)
+  TRY
   {
     SuperClass::parse(node);
@@ -2606,3 +2758,5 @@
     setScalarList();
    }
+  CATCH_DUMP_ATTR
+
 } // namespace xios
Index: XIOS/dev/branch_openmp/src/node/grid.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/grid.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/grid.hpp	(revision 1642)
@@ -19,5 +19,5 @@
 namespace xios {
 
-   /// ////////////////////// Dï¿œï¿œclarations ////////////////////// ///
+   /// ////////////////////// Declarations ////////////////////// ///
 
    class CGridGroup;
@@ -91,7 +91,9 @@
          StdSize  getDataSize(void) const;
 
-         /// Entrï¿œï¿œes-sorties de champs
+         /// Entrees-sorties de champs
          template <int n>
          void inputField(const CArray<double,n>& field, CArray<double,1>& stored) const;
+         template <int n>
+         void maskField(const CArray<double,n>& field, CArray<double,1>& stored) const;
          template <int n>
          void outputField(const CArray<double,1>& stored, CArray<double,n>& field) const;  
@@ -203,9 +205,7 @@
          bool hasTransform();
          size_t getGlobalWrittenSize(void) ;
-         void getLocalMask(CArray<bool,1>& localMask) ;
-         template<int N>
-         void getLocalMask(const CArray<bool,N>& gridMask, CArray<bool,1>& localMask) ;
       public:
          CArray<int, 1> storeIndex_client;
+         CArray<bool, 1> storeMask_client;
 
 /** Map containing indexes that will be sent in sendIndex(). */
@@ -247,4 +247,5 @@
          CArray<size_t,1> indexFromClients;
 
+         bool hasMask(void) const;
          void checkMask(void);
          void createMask(void);
@@ -273,4 +274,5 @@
         void restoreField_arr(const CArray<double, 1>& stored, double* const data) const;
         void uncompressField_arr(const double* const data, CArray<double, 1>& outData) const;
+        void maskField_arr(const double* const data, CArray<double, 1>& stored) const;
 
         void setVirtualDomainGroup(CDomainGroup* newVDomainGroup);
@@ -372,4 +374,5 @@
    template <int n>
    void CGrid::inputField(const CArray<double,n>& field, CArray<double,1>& stored) const
+   TRY
    {
 //#ifdef __XIOS_DEBUG
@@ -383,7 +386,23 @@
       this->storeField_arr(field.dataFirst(), stored);
    }
+   CATCH
+
+   template <int n>
+   void CGrid::maskField(const CArray<double,n>& field, CArray<double,1>& stored) const
+   {
+//#ifdef __XIOS_DEBUG
+      if (this->getDataSize() != field.numElements())
+         ERROR("void CGrid::inputField(const  CArray<double,n>& field, CArray<double,1>& stored) const",
+                << "[ Awaiting data of size = " << this->getDataSize() << ", "
+                << "Received data size = "      << field.numElements() << " ] "
+                << "The data array does not have the right size! "
+                << "Grid = " << this->getId())
+//#endif
+      this->maskField_arr(field.dataFirst(), stored);
+   }
 
    template <int n>
    void CGrid::outputField(const CArray<double,1>& stored, CArray<double,n>& field) const
+   TRY
    {
 //#ifdef __XIOS_DEBUG
@@ -397,4 +416,5 @@
       this->restoreField_arr(stored, field.dataFirst());
    }
+   CATCH
 
    /*!
@@ -406,7 +426,9 @@
    template <int N>
    void CGrid::uncompressField(const CArray<double,N>& data, CArray<double,1>& outData) const
+   TRY
    {      
      uncompressField_arr(data.dataFirst(), outData);
    }
+   CATCH
 
    template<int N>
@@ -416,4 +438,5 @@
                              const CArray<int,1>& axisDomainOrder,
                              bool createMask)
+   TRY
    {
      int idx = 0;
@@ -510,6 +533,6 @@
       ++idx;
     }
-
-   }
+   }
+   CATCH_DUMP_ATTR
 
    template<int N>
@@ -517,4 +540,5 @@
                                   const std::vector<int>& eachDimSize,
                                   bool newValue)
+   TRY
    {
       if (N != eachDimSize.size())
@@ -531,4 +555,5 @@
       gridMask = newValue;
    }
+   CATCH_DUMP_ATTR
                                  
 
@@ -540,4 +565,5 @@
    template<int N>
    void CGrid::modifyGridMask(CArray<bool,N>& gridMask, const CArray<int,1>& indexToModify, bool valueToModify)
+   TRY
    {     
      int num = indexToModify.numElements();
@@ -547,48 +573,9 @@
      }
    }
+   CATCH_DUMP_ATTR
+
    ///--------------------------------------------------------------
 
 
-/*!
-  A grid can have multiple dimension, so can its mask in the form of multi-dimension array.
-It's not a good idea to store all multi-dimension arrays corresponding to each mask.
-One of the ways is to convert this array into 1-dimension one and every process is taken place on it.
-  \param [in] multi-dimension array grid mask
-*/
-template<int N>
-void CGrid::getLocalMask(const CArray<bool,N>& gridMask, CArray<bool,1>& localMask)
-{
-  if (gridMask.isEmpty()) return ;
-  int dim = gridMask.dimensions();
-  std::vector<int> dimensionSizes(dim);
-  for (int i = 0; i < dim; ++i) dimensionSizes[i] = gridMask.extent(i);
-
-  std::vector<int> idxLoop(dim,0);
-  int ssize = gridMask.numElements(), idx = 0;
-  localMask.resize(ssize);
-  while (idx < ssize)
-  {
-    for (int i = 0; i < dim-1; ++i)
-    {
-      if (idxLoop[i] == dimensionSizes[i])
-      {
-        idxLoop[i] = 0;
-        ++idxLoop[i+1];
-      }
-    }
-
-    int maskIndex = idxLoop[0];
-    int mulDim = 1;
-    for (int k = 1; k < dim; ++k)
-    {
-      mulDim *= dimensionSizes[k-1];
-      maskIndex += idxLoop[k]*mulDim;
-    }
-    localMask(maskIndex) = *(gridMask.dataFirst()+maskIndex);
-
-    ++idxLoop[0];
-    ++idx;
-  }
-}
 
    // Declare/Define CGridGroup and CGridDefinition
Index: XIOS/dev/branch_openmp/src/node/interpolate_axis.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/interpolate_axis.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/interpolate_axis.hpp	(revision 1642)
@@ -62,5 +62,4 @@
       static CTransformation<CAxis>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CInterpolateAxis
 
Index: XIOS/dev/branch_openmp/src/node/interpolate_domain.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/interpolate_domain.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/interpolate_domain.hpp	(revision 1642)
@@ -60,5 +60,4 @@
       static CTransformation<CDomain>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CInterpolateDomain
 
Index: XIOS/dev/branch_openmp/src/node/inverse_axis.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/inverse_axis.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/inverse_axis.hpp	(revision 1642)
@@ -59,5 +59,4 @@
       static CTransformation<CAxis>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
 
   }; // class CInverseAxis
Index: XIOS/dev/branch_openmp/src/node/mesh.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/mesh.cpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/mesh.cpp	(revision 1642)
@@ -6,6 +6,6 @@
 
 #include "mesh.hpp"
-using namespace ep_lib;
 #include <boost/functional/hash.hpp>
+//#include <unordered_map>
 
 namespace xios {
@@ -33,6 +33,6 @@
   }
 
-  std::map <StdString, CMesh> *CMesh::meshList_ptr = 0;
-  std::map <StdString, vector<int> > *CMesh::domainList_ptr = 0;
+  std::map <StdString, CMesh> CMesh::meshList = std::map <StdString, CMesh>();
+  std::map <StdString, vector<int> > CMesh::domainList = std::map <StdString, vector<int> >();
 
 ///---------------------------------------------------------------
@@ -45,20 +45,17 @@
   CMesh* CMesh::getMesh (StdString meshName, int nvertex)
   {
-    if(CMesh::domainList_ptr == NULL) CMesh::domainList_ptr = new std::map <StdString, vector<int> >();
-    if(CMesh::meshList_ptr == NULL)   CMesh::meshList_ptr   = new std::map <StdString, CMesh>();
-
-    CMesh::domainList_ptr->at(meshName).push_back(nvertex);
-
-    if ( CMesh::meshList_ptr->begin() != CMesh::meshList_ptr->end() )
-    {
-      for (std::map<StdString, CMesh>::iterator it=CMesh::meshList_ptr->begin(); it!=CMesh::meshList_ptr->end(); ++it)
+    CMesh::domainList[meshName].push_back(nvertex);
+
+    if ( CMesh::meshList.begin() != CMesh::meshList.end() )
+    {
+      for (std::map<StdString, CMesh>::iterator it=CMesh::meshList.begin(); it!=CMesh::meshList.end(); ++it)
       {
         if (it->first == meshName)
-          return &meshList_ptr->at(meshName);
+          return &meshList[meshName];
         else
         {
           CMesh newMesh;
-          CMesh::meshList_ptr->insert( make_pair(meshName, newMesh) );
-          return &meshList_ptr->at(meshName);
+          CMesh::meshList.insert( make_pair(meshName, newMesh) );
+          return &meshList[meshName];
         }
       }
@@ -67,6 +64,6 @@
     {
       CMesh newMesh;
-      CMesh::meshList_ptr->insert( make_pair(meshName, newMesh) );
-      return &meshList_ptr->at(meshName);
+      CMesh::meshList.insert( make_pair(meshName, newMesh) );
+      return &meshList[meshName];
     }
   }
@@ -227,4 +224,181 @@
  * \param [in] bounds_lat Array of boundary latitudes. Its size depends on the element type.
  */
+//  void CMesh::createMesh(const CArray<double, 1>& lonvalue, const CArray<double, 1>& latvalue,
+//            const CArray<double, 2>& bounds_lon, const CArray<double, 2>& bounds_lat)
+//  {
+//    int nvertex = (bounds_lon.numElements() == 0) ? 1 : bounds_lon.rows();
+//
+//    if (nvertex == 1)
+//    {
+//      nbNodes_ = lonvalue.numElements();
+//      node_lon.resizeAndPreserve(nbNodes_);
+//      node_lat.resizeAndPreserve(nbNodes_);
+//      for (int nn = 0; nn < nbNodes_; ++nn)
+//      {
+//        if (map_nodes.find(make_pair (lonvalue(nn), latvalue(nn))) == map_nodes.end())
+//        {
+//          map_nodes[make_pair (lonvalue(nn), latvalue(nn))] = nn ;
+//          node_lon(nn) = lonvalue(nn);
+//          node_lat(nn) = latvalue(nn);
+//        }
+//      }
+//    }
+//    else if (nvertex == 2)
+//    {
+//      nbEdges_ = bounds_lon.shape()[1];
+//
+//      // Create nodes and edge_node connectivity
+//      node_lon.resizeAndPreserve(nbEdges_*nvertex); // Max possible number of nodes
+//      node_lat.resizeAndPreserve(nbEdges_*nvertex);
+//      edge_nodes.resizeAndPreserve(nvertex, nbEdges_);
+//
+//      for (int ne = 0; ne < nbEdges_; ++ne)
+//      {
+//        for (int nv = 0; nv < nvertex; ++nv)
+//        {
+//          if (map_nodes.find(make_pair (bounds_lon(nv, ne), bounds_lat(nv ,ne))) == map_nodes.end())
+//          {
+//            map_nodes[make_pair (bounds_lon(nv, ne), bounds_lat(nv, ne))] = nbNodes_ ;
+//            edge_nodes(nv,ne) = nbNodes_ ;
+//            node_lon(nbNodes_) = bounds_lon(nv, ne);
+//            node_lat(nbNodes_) = bounds_lat(nv, ne);
+//            ++nbNodes_ ;
+//          }
+//          else
+//            edge_nodes(nv,ne) = map_nodes[make_pair (bounds_lon(nv, ne), bounds_lat(nv ,ne))];
+//        }
+//      }
+//      node_lon.resizeAndPreserve(nbNodes_);
+//      node_lat.resizeAndPreserve(nbNodes_);
+//
+//      // Create edges
+//      edge_lon.resizeAndPreserve(nbEdges_);
+//      edge_lat.resizeAndPreserve(nbEdges_);
+//
+//      for (int ne = 0; ne < nbEdges_; ++ne)
+//      {
+//        if (map_edges.find(make_ordered_pair (edge_nodes(0,ne), edge_nodes(1,ne))) == map_edges.end())
+//        {
+//          map_edges[make_ordered_pair ( edge_nodes(0,ne), edge_nodes(1,ne) )] = ne ;
+//          edge_lon(ne) = lonvalue(ne);
+//          edge_lat(ne) = latvalue(ne);
+//        }
+//
+//      }
+//      edgesAreWritten = true;
+//    }
+//    else
+//    {
+//      nbFaces_ = bounds_lon.shape()[1];
+//
+//      // Create nodes and face_node connectivity
+//      node_lon.resizeAndPreserve(nbFaces_*nvertex);  // Max possible number of nodes
+//      node_lat.resizeAndPreserve(nbFaces_*nvertex);
+//      face_nodes.resize(nvertex, nbFaces_);
+//
+//      for (int nf = 0; nf < nbFaces_; ++nf)
+//      {
+//        for (int nv = 0; nv < nvertex; ++nv)
+//        {
+//          if (map_nodes.find(make_pair (bounds_lon(nv, nf), bounds_lat(nv ,nf))) == map_nodes.end())
+//          {
+//            map_nodes[make_pair (bounds_lon(nv, nf), bounds_lat(nv, nf))] = nbNodes_ ;
+//            face_nodes(nv,nf) = nbNodes_ ;
+//            node_lon(nbNodes_) = bounds_lon(nv, nf);
+//            node_lat(nbNodes_) = bounds_lat(nv ,nf);
+//            ++nbNodes_ ;
+//          }
+//          else
+//          {
+//            face_nodes(nv,nf) = map_nodes[make_pair (bounds_lon(nv, nf), bounds_lat(nv ,nf))];
+//          }
+//        }
+//      }
+//      node_lon.resizeAndPreserve(nbNodes_);
+//      node_lat.resizeAndPreserve(nbNodes_);
+//
+//      // Create edges and edge_nodes connectivity
+//      edge_lon.resizeAndPreserve(nbFaces_*nvertex); // Max possible number of edges
+//      edge_lat.resizeAndPreserve(nbFaces_*nvertex);
+//      edge_nodes.resizeAndPreserve(2, nbFaces_*nvertex);
+//      edge_faces.resize(2, nbFaces_*nvertex);
+//      face_edges.resize(nvertex, nbFaces_);
+//      face_faces.resize(nvertex, nbFaces_);
+//
+//      vector<int> countEdges(nbFaces_*nvertex);   // needed in case if edges have been already generated
+//      vector<int> countFaces(nbFaces_);
+//      countEdges.assign(nbFaces_*nvertex, 0);
+//      countFaces.assign(nbFaces_, 0);
+//      int edge;
+//      for (int nf = 0; nf < nbFaces_; ++nf)
+//      {
+//        for (int nv1 = 0; nv1 < nvertex; ++nv1)
+//        {
+//          int nv = 0;
+//          int nv2 = (nv1 < nvertex -1 ) ? (nv1 + 1) : (nv1 + 1 - nvertex); // cyclic rotation
+//          if (map_edges.find(make_ordered_pair (face_nodes(nv1,nf), face_nodes(nv2,nf))) == map_edges.end())
+//          {
+//            map_edges[make_ordered_pair (face_nodes(nv1,nf), face_nodes(nv2,nf))] = nbEdges_ ;
+//            face_edges(nv1,nf) = map_edges[make_ordered_pair (face_nodes(nv1,nf), face_nodes(nv2,nf))];
+//            edge_faces(0,nbEdges_) = nf;
+//            edge_faces(1,nbEdges_) = -999;
+//            face_faces(nv1,nf) = 999999;
+//            edge_nodes(Range::all(),nbEdges_) = face_nodes(nv1,nf), face_nodes(nv2,nf);
+//            edge_lon(nbEdges_) = ( abs( node_lon(face_nodes(nv1,nf)) - node_lon(face_nodes(nv2,nf))) < 180.) ?
+//                        (( node_lon(face_nodes(nv1,nf)) + node_lon(face_nodes(nv2,nf))) * 0.5) :
+//                        (( node_lon(face_nodes(nv1,nf)) + node_lon(face_nodes(nv2,nf))) * 0.5 -180.);
+//            edge_lat(nbEdges_) = ( node_lat(face_nodes(nv1,nf)) + node_lat(face_nodes(nv2,nf)) ) * 0.5;
+//            ++nbEdges_;
+//          }
+//          else
+//          {
+//            edge = map_edges[make_ordered_pair (face_nodes(nv1,nf), face_nodes(nv2,nf))];
+//            face_edges(nv1,nf) = edge;
+//            if (edgesAreWritten)
+//            {
+//              edge_faces(countEdges[edge], edge) = nf;
+//              if (countEdges[edge]==0)
+//              {
+//                face_faces(nv1,nf) = 999999;
+//              }
+//              else
+//              {
+//                int face1 = nf; // = edge_faces(1,edge)
+//                int face2 = edge_faces(0,edge);
+//                face_faces(countFaces[face1], face1) =  face2;
+//                face_faces(countFaces[face2], face2) =  face1;
+//                ++(countFaces[face1]);
+//                ++(countFaces[face2]);
+//              }
+//            }
+//            else
+//            {
+//              edge_faces(1,edge) = nf;
+//              int face1 = nf; // = edge_faces(1,edge)
+//              int face2 = edge_faces(0,edge);
+//              face_faces(countFaces[face1], face1) =  face2;
+//              face_faces(countFaces[face2], face2) =  face1;
+//              ++(countFaces[face1]);
+//              ++(countFaces[face2]);
+//            }
+//            ++(countEdges[edge]);
+//          }
+//        }
+//      }
+//      edge_nodes.resizeAndPreserve(2, nbEdges_);
+//      edge_faces.resizeAndPreserve(2, nbEdges_);
+//      edge_lon.resizeAndPreserve(nbEdges_);
+//      edge_lat.resizeAndPreserve(nbEdges_);
+//
+//      // Create faces
+//      face_lon.resize(nbFaces_);
+//      face_lat.resize(nbFaces_);
+//      face_lon = lonvalue;
+//      face_lat = latvalue;
+//      facesAreWritten = true;
+//
+//    } // nvertex > 2
+//
+//  } // createMesh()
 
 ///----------------------------------------------------------------
@@ -240,5 +414,5 @@
  * \param [in] bounds_lat Array of boundary latitudes. Its size depends on the element type.
  */
-  void CMesh::createMeshEpsilon(const MPI_Comm& comm,
+  void CMesh::createMeshEpsilon(const ep_lib::MPI_Comm& comm,
                                 const CArray<double, 1>& lonvalue, const CArray<double, 1>& latvalue,
                                 const CArray<double, 2>& bounds_lon, const CArray<double, 2>& bounds_lat)
@@ -247,6 +421,6 @@
     int nvertex = (bounds_lon.numElements() == 0) ? 1 : bounds_lon.rows();
     int mpiRank, mpiSize;
-    MPI_Comm_rank(comm, &mpiRank);
-    MPI_Comm_size(comm, &mpiSize);
+    ep_lib::MPI_Comm_rank(comm, &mpiRank);
+    ep_lib::MPI_Comm_size(comm, &mpiSize);
     double prec = 1e-11;  // used in calculations of edge_lon/lat
 
@@ -286,5 +460,5 @@
       unsigned long nbEdgesOnProc = nbEdges_;
       unsigned long nbEdgesAccum;
-      MPI_Scan(&nbEdgesOnProc, &nbEdgesAccum, 1, MPI_UNSIGNED_LONG, MPI_SUM, comm);
+      ep_lib::MPI_Scan(&nbEdgesOnProc, &nbEdgesAccum, 1, EP_UNSIGNED_LONG, EP_SUM, comm);
       nbEdgesAccum -= nbEdges_;
 
@@ -416,7 +590,7 @@
          unsigned long nodeCount = nodeIdx2Idx.size();
          unsigned long nodeStart, nbNodes;
-         MPI_Scan(&nodeCount, &nodeStart, 1, MPI_UNSIGNED_LONG, MPI_SUM, comm);
+         ep_lib::MPI_Scan(&nodeCount, &nodeStart, 1, EP_UNSIGNED_LONG, EP_SUM, comm);
          int nNodes = nodeStart;
-         MPI_Bcast(&nNodes, 1, MPI_UNSIGNED_LONG, mpiSize-1, comm);
+         ep_lib::MPI_Bcast(&nNodes, 1, EP_UNSIGNED_LONG, mpiSize-1, comm);
          nbNodesGlo = nNodes;
 
@@ -509,5 +683,5 @@
       unsigned long nbFacesOnProc = nbFaces_;
       unsigned long nbFacesAccum;
-      MPI_Scan(&nbFacesOnProc, &nbFacesAccum, 1, MPI_UNSIGNED_LONG, MPI_SUM, comm);
+      ep_lib::MPI_Scan(&nbFacesOnProc, &nbFacesAccum, 1, EP_UNSIGNED_LONG, EP_SUM, comm);
       nbFacesAccum -= nbFaces_;
 
@@ -633,7 +807,7 @@
 
         unsigned long edgeStart, nbEdges;
-        MPI_Scan(&edgeCount, &edgeStart, 1, MPI_UNSIGNED_LONG, MPI_SUM, comm);
+        ep_lib::MPI_Scan(&edgeCount, &edgeStart, 1, EP_UNSIGNED_LONG, EP_SUM, comm);
         int nEdges = edgeStart;
-        MPI_Bcast(&nEdges, 1, MPI_UNSIGNED_LONG, mpiSize-1, comm);
+        ep_lib::MPI_Bcast(&nEdges, 1, EP_UNSIGNED_LONG, mpiSize-1, comm);
         nbEdgesGlo = nEdges;
 
@@ -854,7 +1028,7 @@
         unsigned long edgeCount = edgeIdx2Idx.size();
         unsigned long edgeStart, nbEdges;
-        MPI_Scan(&edgeCount, &edgeStart, 1, MPI_UNSIGNED_LONG, MPI_SUM, comm);
+        ep_lib::MPI_Scan(&edgeCount, &edgeStart, 1, EP_UNSIGNED_LONG, EP_SUM, comm);
         int nEdges = edgeStart;
-        MPI_Bcast(&nEdges, 1, MPI_UNSIGNED_LONG, mpiSize-1, comm);
+        ep_lib::MPI_Bcast(&nEdges, 1, EP_UNSIGNED_LONG, mpiSize-1, comm);
         nbEdgesGlo = nEdges;
 
@@ -1124,7 +1298,7 @@
         unsigned long nodeCount = nodeIdx2Idx.size();
         unsigned long nodeStart, nbNodes;
-        MPI_Scan(&nodeCount, &nodeStart, 1, MPI_UNSIGNED_LONG, MPI_SUM, comm);
+        ep_lib::MPI_Scan(&nodeCount, &nodeStart, 1, EP_UNSIGNED_LONG, EP_SUM, comm);
         int nNodes = nodeStart;
-        MPI_Bcast(&nNodes, 1, MPI_UNSIGNED_LONG, mpiSize-1, comm);
+        ep_lib::MPI_Bcast(&nNodes, 1, EP_UNSIGNED_LONG, mpiSize-1, comm);
         nbNodesGlo = nNodes;
 
@@ -1244,7 +1418,7 @@
         unsigned long edgeCount = edgeIdx2Idx.size();
         unsigned long edgeStart, nbEdges;
-        MPI_Scan(&edgeCount, &edgeStart, 1, MPI_UNSIGNED_LONG, MPI_SUM, comm);
+        ep_lib::MPI_Scan(&edgeCount, &edgeStart, 1, EP_UNSIGNED_LONG, EP_SUM, comm);
         int nEdges = edgeStart;
-        MPI_Bcast(&nEdges, 1, MPI_UNSIGNED_LONG, mpiSize-1, comm);
+        ep_lib::MPI_Bcast(&nEdges, 1, EP_UNSIGNED_LONG, mpiSize-1, comm);
         nbEdgesGlo = nEdges;
 
@@ -1440,5 +1614,5 @@
    */
 
-  void CMesh::getGloNghbFacesNodeType(const MPI_Comm& comm, const CArray<int, 1>& face_idx,
+  void CMesh::getGloNghbFacesNodeType(const ep_lib::MPI_Comm& comm, const CArray<int, 1>& face_idx,
                                const CArray<double, 2>& bounds_lon, const CArray<double, 2>& bounds_lat,
                                CArray<int, 2>& nghbFaces)
@@ -1449,6 +1623,6 @@
 
     int mpiRank, mpiSize;
-    MPI_Comm_rank(comm, &mpiRank);
-    MPI_Comm_size(comm, &mpiSize);
+    ep_lib::MPI_Comm_rank(comm, &mpiRank);
+    ep_lib::MPI_Comm_size(comm, &mpiSize);
 
     // (1) Generating unique node indexes
@@ -1596,5 +1770,5 @@
    */
 
-  void CMesh::getGloNghbFacesEdgeType(const MPI_Comm& comm, const CArray<int, 1>& face_idx,
+  void CMesh::getGloNghbFacesEdgeType(const ep_lib::MPI_Comm& comm, const CArray<int, 1>& face_idx,
                                const CArray<double, 2>& bounds_lon, const CArray<double, 2>& bounds_lat,
                                CArray<int, 2>& nghbFaces)
@@ -1605,6 +1779,6 @@
 
     int mpiRank, mpiSize;
-    MPI_Comm_rank(comm, &mpiRank);
-    MPI_Comm_size(comm, &mpiSize);
+    ep_lib::MPI_Comm_rank(comm, &mpiRank);
+    ep_lib::MPI_Comm_size(comm, &mpiSize);
 
     // (1) Generating unique node indexes
@@ -1777,5 +1951,5 @@
    */
 
-  void CMesh::getGlobalNghbFaces(const int nghbType, const MPI_Comm& comm,
+  void CMesh::getGlobalNghbFaces(const int nghbType, const ep_lib::MPI_Comm& comm,
                                  const CArray<int, 1>& face_idx,
                                  const CArray<double, 2>& bounds_lon, const CArray<double, 2>& bounds_lat,
Index: XIOS/dev/branch_openmp/src/node/mesh.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/mesh.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/mesh.hpp	(revision 1642)
@@ -83,8 +83,6 @@
       int nbFaces_;
 
-      static std::map <StdString, CMesh> *meshList_ptr;
-      #pragma omp threadprivate(meshList_ptr)
-      static std::map <StdString, vector<int> > *domainList_ptr;
-      #pragma omp threadprivate(domainList_ptr)
+      static std::map <StdString, CMesh> meshList;
+      static std::map <StdString, vector<int> > domainList;
       CClientClientDHTSizet* pNodeGlobalIndex;                    // pointer to a map <nodeHash, nodeIdxGlo>
       CClientClientDHTSizet* pEdgeGlobalIndex;                    // pointer to a map <edgeHash, edgeIdxGlo>
Index: XIOS/dev/branch_openmp/src/node/node_enum.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/node_enum.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/node_enum.hpp	(revision 1642)
@@ -23,4 +23,5 @@
          eZoomAxis,
          eInterpolateAxis,
+         eExtractAxis,
          eZoomDomain,
          eInterpolateDomain,
@@ -38,5 +39,6 @@
          eDuplicateScalarToAxis,
          eReduceScalarToScalar,
-         eReorderDomain
+         eReorderDomain,
+         eExtractDomain
        } ENodeType;
 
Index: XIOS/dev/branch_openmp/src/node/node_type.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/node_type.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/node_type.hpp	(revision 1642)
@@ -13,4 +13,5 @@
 #include "zoom_axis.hpp"
 #include "interpolate_axis.hpp"
+#include "extract_axis.hpp"
 #include "zoom_domain.hpp"
 #include "interpolate_domain.hpp"
@@ -29,4 +30,5 @@
 #include "reduce_scalar_to_scalar.hpp"
 #include "reorder_domain.hpp"
+#include "extract_domain.hpp"
 
 
Index: XIOS/dev/branch_openmp/src/node/reduce_axis_to_axis.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/reduce_axis_to_axis.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/reduce_axis_to_axis.hpp	(revision 1642)
@@ -59,5 +59,4 @@
       static CTransformation<CAxis>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CReduceAxisToAxis
 
Index: XIOS/dev/branch_openmp/src/node/reduce_axis_to_scalar.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/reduce_axis_to_scalar.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/reduce_axis_to_scalar.hpp	(revision 1642)
@@ -59,5 +59,4 @@
       static CTransformation<CScalar>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CReduceAxisToScalar
 
Index: XIOS/dev/branch_openmp/src/node/reduce_domain_to_axis.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/reduce_domain_to_axis.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/reduce_domain_to_axis.hpp	(revision 1642)
@@ -60,5 +60,4 @@
       static CTransformation<CAxis>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CReduceDomainToAxis
 
Index: XIOS/dev/branch_openmp/src/node/reduce_domain_to_scalar.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/reduce_domain_to_scalar.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/reduce_domain_to_scalar.hpp	(revision 1642)
@@ -60,5 +60,4 @@
       static CTransformation<CScalar>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CReduceDomainToScalar
 
Index: XIOS/dev/branch_openmp/src/node/reduce_scalar_to_scalar.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/reduce_scalar_to_scalar.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/reduce_scalar_to_scalar.hpp	(revision 1642)
@@ -59,5 +59,4 @@
       static CTransformation<CScalar>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CReduceScalarToScalar
 
Index: XIOS/dev/branch_openmp/src/node/reorder_domain.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/reorder_domain.hpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/reorder_domain.hpp	(revision 1642)
@@ -60,5 +60,4 @@
       static CTransformation<CDomain>* create(const StdString& id, xml::CXMLNode* node);
       static bool _dummyRegistered;
-      #pragma omp threadprivate(_dummyRegistered)
   }; // class CReorderDomain
 
Index: XIOS/dev/branch_openmp/src/node/scalar.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/scalar.cpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/scalar.cpp	(revision 1642)
@@ -27,7 +27,6 @@
    { /* Ne rien faire de plus */ }
 
-
-   std::map<StdString, ETranformationType> *CScalar::transformationMapList_ptr = 0;
-
+   std::map<StdString, ETranformationType> CScalar::transformationMapList_ = std::map<StdString, ETranformationType>();
+   bool CScalar::dummyTransformationMapList_ = CScalar::initializeTransformationMap(CScalar::transformationMapList_);
    bool CScalar::initializeTransformationMap(std::map<StdString, ETranformationType>& m)
    {
@@ -36,13 +35,4 @@
      m["reduce_domain"] = TRANS_REDUCE_DOMAIN_TO_SCALAR;
      m["reduce_scalar"] = TRANS_REDUCE_SCALAR_TO_SCALAR;
-   }
-
-   bool CScalar::initializeTransformationMap()
-   {
-     CScalar::transformationMapList_ptr = new std::map<StdString, ETranformationType>();
-     (*CScalar::transformationMapList_ptr)["reduce_axis"]   = TRANS_REDUCE_AXIS_TO_SCALAR;
-     (*CScalar::transformationMapList_ptr)["extract_axis"]  = TRANS_EXTRACT_AXIS_TO_SCALAR;
-     (*CScalar::transformationMapList_ptr)["reduce_domain"] = TRANS_REDUCE_DOMAIN_TO_SCALAR;
-     (*CScalar::transformationMapList_ptr)["reduce_scalar"] = TRANS_REDUCE_SCALAR_TO_SCALAR;
    }
 
@@ -175,7 +165,6 @@
 
         nodeElementName = node.getElementName();
-        if(CScalar::transformationMapList_ptr == 0) initializeTransformationMap();
-        std::map<StdString, ETranformationType>::const_iterator ite = transformationMapList_ptr->end(), it;
-        it = transformationMapList_ptr->find(nodeElementName);
+        std::map<StdString, ETranformationType>::const_iterator ite = transformationMapList_.end(), it;
+        it = transformationMapList_.find(nodeElementName);
         if (ite != it)
         {
